#ifndef ACCOUNTPANEL_H
#define ACCOUNTPANEL_H

#include <wx/wx.h>
#include <wx/grid.h>
#include <wx/treectrl.h>
#include <wx/pie/pieplot.h>
#include <wx/chartpanel.h>

#define OWN_CYAN wxColour(0x99, 0xCC, 0xFF)
#define OWN_YELLOW wxColour(0xFF, 0xFF, 0x99)
#define OWN_GREEN wxColour(0x3D, 0xEB, 0x3D)

#define DEFAULT_FONT_NAME _("Liberation Sans")
#define DEFAULT_FONT_SIZE 12
#define DEFAULT_FONT(font_name)  wxFont font_name(DEFAULT_FONT_SIZE, wxFONTFAMILY_DEFAULT, wxFONTSTYLE_NORMAL, wxFONTWEIGHT_NORMAL, false, DEFAULT_FONT_NAME);

enum {DESCRIPTION, DATE, DEBIT, CREDIT, CATEGORY, ACCOUNT, VIEW, NUMBER_COLS};
enum {CUR_CREDIT, CUR_DEBIT, TOTAL_CREDIT, TOTAL_DEBIT, REMAINS, STATS_ROW, CATS_STATS};

#include <controller/KissCount.h>
#include "wxUI.h"
#include <model/model.h>
#include "GridAccount.h"
#include <wx/category/categorysimpledataset.h>

class wxUI;
class KissCount;

class AccountPanel: public wxPanel
{
public:
  AccountPanel(KissCount* kiss, wxUI *parent);
  ~AccountPanel();
  void ChangeUser();
  void LoadYear(int year);
  void ShowMonth(int year, int month);

private:
  KissCount* _kiss;
  wxUI* _wxUI;
  wxTreeCtrl _tree;
  GridAccount* _grid;
  wxGrid *_statsGrid;
  PiePlot* _pie;
  double *_categoriesValues;
  std::map<wxString, int> _categoriesIndexes;
  std::list<operation>* _curOperations;
  int _curMonth, _curYear;
  wxString* _categories, *_accounts;
  CategorySimpleDataset* _dataset;

  void UpdateStats();
};

#endif
